/**
 * DO NOT EDIT
 *
 * This file was automatically generated by
 *   https://github.com/Polymer/tools/tree/master/packages/gen-typescript-declarations
 *
 * To modify these typings, edit the source file(s):
 *   api-type-documentation.js
 */


// tslint:disable:variable-name Describing an API that's defined elsewhere.
// tslint:disable:no-any describes the API as best we are able today

import {LitElement, html, css} from 'lit-element';

import {AmfHelperMixin} from '@api-components/amf-helper-mixin/amf-helper-mixin.js';

declare namespace ApiElements {

  /**
   * `api-type-documentation`
   *
   * A documentation module for RAML types (resources) using AMF data model.
   *
   * ## Styling
   *
   * `<api-type-documentation>` provides the following custom properties and mixins for styling:
   *
   * Custom property | Description | Default
   * ----------------|-------------|----------
   * `--api-type-documentation` | Mixin applied to this elment | `{}`
   * `--arc-font-headline` | Theme mixin, applied to the title | `{}`
   * `--api-type-documentation-title` | Mixin applied to the title | `{}`
   * `--api-type-documentation-title-narrow` | Mixin applied to the title in narrow layout | `{}`
   */
  class ApiTypeDocumentation extends
    AmfHelperMixin(
    Object) {

    /**
     * A type definition to render.
     * This should be a one of the following AMF types:
     *
     * - `http://www.w3.org/ns/shacl#NodeShape` (Object)
     * - `http://raml.org/vocabularies/shapes#UnionShape` (Union)
     * - `http://raml.org/vocabularies/shapes#ArrayShape` (Array)
     * - `http://raml.org/vocabularies/shapes#ScalarShape` (single property)
     */
    type: object|any[]|null;

    /**
     * `raml-aware` scope property to use.
     */
    aware: string|null|undefined;

    /**
     * Computed value, title of the type.
     */
    typeTitle: string|null|undefined;

    /**
     * Computed value of method description from `method` property.
     */
    description: string|null|undefined;

    /**
     * Computed value from current `method`. True if the model contains
     * custom properties (annotations in RAML).
     */
    hasCustomProperties: boolean|null|undefined;

    /**
     * Computed value, true when passed model represents a schema
     * (like XML)
     */
    isSchema: boolean|null|undefined;

    /**
     * Set to render a mobile friendly view.
     */
    narrow: boolean|null|undefined;

    /**
     * A media type to use to generate examples.
     */
    mediaType: string|null|undefined;

    /**
     * A list of supported media types for the type.
     * This is used by `api-resource-example-document` to compute examples.
     * In practive it should be value of raml's `mediaType`.
     *
     * Each item in the array is just a name of thr media type.
     *
     * Example:
     *
     * ```json
     * ["application/json", "application/xml"]
     * ```
     */
    mediaTypes: Array<String|null>|null;

    /**
     * Computes `description` property
     *
     * @param shape AMF model for data type
     */
    _computeDescription(shape: object|null): String|null|undefined;
    render(): any;
    _apiChangedHandler(e: any): void;
    _typeChanged(type: any): void;

    /**
     * Computes `typeTitle` property
     *
     * @param shape AMF model for data type
     */
    _computeTitle(shape: object|null): String|null|undefined;

    /**
     * Computes value for `isSchema` property.
     *
     * @param shape AMF `supportedOperation` model
     */
    _computeIsSchema(shape: object|null): Boolean|null|undefined;
  }
}

declare global {

  interface HTMLElementTagNameMap {
    "api-type-documentation": ApiElements.ApiTypeDocumentation;
  }
}
